//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3992F72601AA.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3992F72601AA.cm

//## begin module%3992F72601AA.cp preserve=no
//## end module%3992F72601AA.cp

//## Module: DataFactory%3992F72601AA; Package body
//## Subsystem: XSModel::DataFactory%3994285E0087
//## Source file: /data/verisB/dorman/Xspec/src/XSModel/DataFactory/DataFactory.cxx

//## begin module%3992F72601AA.additionalIncludes preserve=no
//## end module%3992F72601AA.additionalIncludes

//## begin module%3992F72601AA.includes preserve=yes
//## end module%3992F72601AA.includes

// Background
#include <XSModel/Data/BackCorr/Background.h>
// DataSet
#include <XSModel/Data/DataSet.h>
// Response
#include <XSModel/Data/Detector/Response.h>
// XSutility
#include <XSUtil/Utils/XSutility.h>
// DataFactory
#include <XSModel/DataFactory/DataFactory.h>


//## begin module%3992F72601AA.declarations preserve=no
//## end module%3992F72601AA.declarations

//## begin module%3992F72601AA.additionalDeclarations preserve=yes
//## end module%3992F72601AA.additionalDeclarations


// Class DataFactory 

DataFactory::DataFactory()
  //## begin DataFactory::DataFactory%3992ECC901AB_const.hasinit preserve=no
  //## end DataFactory::DataFactory%3992ECC901AB_const.hasinit
  //## begin DataFactory::DataFactory%3992ECC901AB_const.initialization preserve=yes
  //## end DataFactory::DataFactory%3992ECC901AB_const.initialization
{
  //## begin DataFactory::DataFactory%3992ECC901AB_const.body preserve=yes
  //## end DataFactory::DataFactory%3992ECC901AB_const.body
}


DataFactory::~DataFactory()
{
  //## begin DataFactory::~DataFactory%3992ECC901AB_dest.body preserve=yes
  //## end DataFactory::~DataFactory%3992ECC901AB_dest.body
}


// Additional Declarations
  //## begin DataFactory%3992ECC901AB.declarations preserve=yes
  //## end DataFactory%3992ECC901AB.declarations

// Class DataPrototype 

DataPrototype::DataPrototype(const DataPrototype &right)
  //## begin DataPrototype::DataPrototype%39A3D63A024C_copy.initialization preserve=yes
  : m_protoBackground(right.MakeBackground()),
  m_protoCorrection(right.MakeCorrection()),
  m_protoDataSet(right.MakeDataSet()),
  m_protoResponse(right.MakeResponse())
  //## end DataPrototype::DataPrototype%39A3D63A024C_copy.initialization
{
  //## begin DataPrototype::DataPrototype%39A3D63A024C_copy.body preserve=yes
  //## end DataPrototype::DataPrototype%39A3D63A024C_copy.body
}

DataPrototype::DataPrototype (DataSet* pDataSet, Response* pResponse, Background* pBackground, Correction* pCorrection)
  //## begin DataPrototype::DataPrototype%39A3DBE50232.hasinit preserve=yes
  : m_protoBackground(pBackground),
  m_protoCorrection(pCorrection),
  m_protoDataSet(pDataSet),
  m_protoResponse(pResponse)
  //## end DataPrototype::DataPrototype%39A3DBE50232.hasinit
  //## begin DataPrototype::DataPrototype%39A3DBE50232.initialization preserve=yes
  //## end DataPrototype::DataPrototype%39A3DBE50232.initialization
{
  //## begin DataPrototype::DataPrototype%39A3DBE50232.body preserve=yes
  //## end DataPrototype::DataPrototype%39A3DBE50232.body
}


DataPrototype::~DataPrototype()
{
  //## begin DataPrototype::~DataPrototype%39A3D63A024C_dest.body preserve=yes
  // exception safe. delete doesn't throw.      
  delete m_protoDataSet;
  delete m_protoResponse;
  delete m_protoBackground;
  delete m_protoCorrection;
  //## end DataPrototype::~DataPrototype%39A3D63A024C_dest.body
}


DataPrototype & DataPrototype::operator=(const DataPrototype &right)
{
  //## begin DataPrototype::operator=%39A3D63A024C_assign.body preserve=yes
  DataPrototype* temp = new DataPrototype(right);
  swap(*temp);
  return *this;
  //## end DataPrototype::operator=%39A3D63A024C_assign.body
}



//## Other Operations (implementation)
DataSet* DataPrototype::MakeDataSet () const
{
  //## begin DataPrototype::MakeDataSet%39D0CFB30313.body preserve=yes
   return m_protoDataSet->clone();
  //## end DataPrototype::MakeDataSet%39D0CFB30313.body
}

Response* DataPrototype::MakeResponse () const
{
  //## begin DataPrototype::MakeResponse%39D0CFB703DC.body preserve=yes
   return m_protoResponse->clone();
  //## end DataPrototype::MakeResponse%39D0CFB703DC.body
}

Background* DataPrototype::MakeBackground () const
{
  //## begin DataPrototype::MakeBackground%39D0CFC10214.body preserve=yes
   return m_protoBackground->clone();
  //## end DataPrototype::MakeBackground%39D0CFC10214.body
}

Correction* DataPrototype::MakeCorrection () const
{
  //## begin DataPrototype::MakeCorrection%39D0CFC60316.body preserve=yes
   if (m_protoCorrection) return m_protoCorrection->clone();
   else return 0;
  //## end DataPrototype::MakeCorrection%39D0CFC60316.body
}

void DataPrototype::swap (DataPrototype& right) throw ()
{
  //## begin DataPrototype::swap%39E32A250189.body preserve=yes
  std::swap(m_protoDataSet,right.m_protoDataSet);
  std::swap(m_protoBackground,right.m_protoBackground);
  std::swap(m_protoCorrection,right.m_protoCorrection);
  std::swap(m_protoResponse,right.m_protoResponse); 
  //## end DataPrototype::swap%39E32A250189.body
}

//## begin module%3992F72601AA.epilog preserve=yes
//## end module%3992F72601AA.epilog
